#include "../solver_configurations.h"

#include <math.h>

SymplecticSolver yoshida8()
{
    const double w0 = -pow(2.0, 1.0 / 3.0) / (2 - pow(2.0, 1.0 / 3.0));
    const double w1 = -0.161582374150097E1;
    const double w2 = -0.244699182370524E1;
    const double w3 = -0.716989419708120E-2;
    const double w4 = 0.244002732616735E1;
    const double w5 = 0.157739928123617E0;
    const double w6 = 0.182020630970714E1;
    const double w7 = 0.104242620869991E1;

    static double yoshida8_c[16] = {w7 / 2,
                                    (w6 + w7) / 2,
                                    (w6 + w5) / 2,
                                    (w5 + w4) / 2,
                                    (w4 + w3) / 2,
                                    (w3 + w2) / 2,
                                    (w2 + w1) / 2,
                                    (w0 + w1) / 2,
                                    (w0 + w1) / 2,
                                    (w2 + w1) / 2,
                                    (w3 + w2) / 2,
                                    (w4 + w3) / 2,
                                    (w5 + w4) / 2,
                                    (w6 + w5) / 2,
                                    (w6 + w7) / 2,
                                    w7 / 2};
    static double yoshida8_d[16] = {w7, w6, w5, w4, w3, w2, w1, w0, w1, w2, w3, w4, w5, w6, w7, 0.0};

    static SymplecticSolver solver = {
        .num_stages = 16,
        .c = yoshida8_c,
        .d = yoshida8_d};
    return solver;
}